//+------------------------------------------------------------------+
//|                                             Angle of average.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property  copyright "mladen"

#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  LimeGreen
#property  indicator_color2  LimeGreen
#property  indicator_color3  Orange
#property  indicator_color4  Orange
#property  indicator_color5  Gray
#property  indicator_width1  2
#property  indicator_width3  2
#property  indicator_width5  2


//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern double Length       = 50;
extern double Phase        = 0;
extern bool   Double       = false;
extern int    AppliedPrice = 0;
extern int    SlopeBars    = 1;
extern bool   Interpolate  = true;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double slope[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,Buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,Buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,Buffer5);
   SetIndexBuffer(5,slope);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" Slope of jurik ("+DoubleToStr(Length,2)+")");
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int countedBars = IndicatorCounted();
      if(countedBars<0) return(-1);
      if(countedBars>0) countedBars--;
         int limit=MathMin(Bars-countedBars,Bars-1);
         if (returnBars) { Buffer1[0] = limit+1; return(0); }
         if (timeFrame!=Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  Buffer5[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Phase,Double,AppliedPrice,SlopeBars,4,y);
                  Buffer1[i] = EMPTY_VALUE;
                  Buffer2[i] = EMPTY_VALUE;
                  Buffer3[i] = EMPTY_VALUE;
                  Buffer4[i] = EMPTY_VALUE;
                  slope[i] = slope[i+1];
                     if (Buffer5[i]>Buffer5[i+1]) slope[i] =  1;
                     if (Buffer5[i]<Buffer5[i+1]) slope[i] = -1;
                     if (Buffer5[i]>0)
                        if (slope[i]==1)
                              Buffer1[i] = Buffer5[i];
                        else  Buffer2[i] = Buffer5[i];
                     if (Buffer5[i]<0)
                        if (slope[i]==1)
                              Buffer4[i] = Buffer5[i];
                        else  Buffer3[i] = Buffer5[i];

                  //
                  //
                  //
                  //
                  //
                  
                  if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

                  //
                  //
                  //
                  //
                  //

                  datetime time = iTime(NULL,timeFrame,y);
                  for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                  for(int x = 1; x < n; x++)
                  {
                     Buffer5[i+x] = Buffer5[i] + (Buffer5[i+n] - Buffer5[i]) * x/n;
                     if (Buffer1[i]!=EMPTY_VALUE) Buffer1[i+x] = Buffer5[i+x];
                     if (Buffer2[i]!=EMPTY_VALUE) Buffer2[i+x] = Buffer5[i+x];
                     if (Buffer3[i]!=EMPTY_VALUE) Buffer3[i+x] = Buffer5[i+x];
                     if (Buffer4[i]!=EMPTY_VALUE) Buffer4[i+x] = Buffer5[i+x];
                  }               
            }
            return(0);                  
         }

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      double change = iDSmooth(getPrice(AppliedPrice,i),Length,Phase,Double,i,0)-iDSmooth(getPrice(AppliedPrice,i+SlopeBars),Length,Phase,Double,i+SlopeBars,20);

      //
      //
      //
      //
      //
      
         Buffer1[i] = EMPTY_VALUE;
         Buffer2[i] = EMPTY_VALUE;
         Buffer3[i] = EMPTY_VALUE;
         Buffer4[i] = EMPTY_VALUE;
         Buffer5[i] = change;
            slope[i] = slope[i+1];
               if (Buffer5[i]>Buffer5[i+1]) slope[i] =  1;
               if (Buffer5[i]<Buffer5[i+1]) slope[i] = -1;
               if (change>0)
                  if (slope[i]==1)
                        Buffer1[i] = change;
                  else  Buffer2[i] = change;
               if (change<0)
                  if (slope[i]==1)
                        Buffer4[i] = change;
                  else  Buffer3[i] = change;
   }
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7:     return((Open[i]+Close[i])/2.0);
      case 8:     return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      default :   return(iMA(NULL,0,1,0,MODE_SMA,type,i));
   }      
}
	   
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}